################################################################################
# ModuleName  : com
# $File$
# $Author$
# $Date$
################################################################################
# Description :
# usage: python alarm.py <args>
# Author Pushparaj
################################################################################
import sys
import string
import xml.dom.minidom
from string import Template
import time
import getpass

headerTemplate = Template("""
/******************************************************************************
* This file is auto-generated by OpenClovis IDE
*
* clASPCfg.c
*
*****************************************************************************/
/*INCLUDES*/

#include <clCommon.h>
#include <clCorMetaData.h>
""")


iocHeaderTemplate = Template("""\

/* IOC configuration */

ClUint32T gClIocMaxPriorityQSize=${maxpriorityQsize};
ClUint32T gClIocMaxNumOfPriorities=${maxpriorities};
ClUint32T gClIocReassemblyTimeout=${reassemblytimeout};
ClUint32T gClIocTLMaxEntries=${tlmaxentries};
ClUint32T gClIocHeartbeatTimeInterval=${hearbeatinterval};


""")

nsHeaderTemplate = Template("""\
 
/* NS configuration */
 
ClUint32T gClnsMaxNoEntries=${maxentries}; /* Max no. of entries per context */
ClUint32T gClnsMaxNoGlobalContexts=${maxglobalcontexts};   /* Max no. of user defined global contexts */
ClUint32T gClnsMaxNoLocalContexts=${maxlocalcontexts};   /* Max no. of node local user contexts */

""")
rmdHeaderTemplate = Template("""\

/* RMD configuration */

ClUint16T gClRmdMaxRetries=${maxretries};
""")

#------------------------------------------------------------------------------	
#------------------------------------------------------------------------------
def createNSHeader(ns):
	map = dict();
	map["maxentries"] = ns.attributes["maxentries"].value
	map["maxglobalcontexts"] = ns.attributes["maxglobalcontexts"].value
	map["maxlocalcontexts"] = ns.attributes["maxlocalcontexts"].value
	
	result = nsHeaderTemplate.safe_substitute(map)
	return result
#------------------------------------------------------------------------------

#------------------------------------------------------------------------------
def createRMDHeader(rmd):
	map = dict();
	map["maxretries"] = rmd.attributes["maxretries"].value
		
	result = rmdHeaderTemplate.safe_substitute(map)
	return result
	
#------------------------------------------------------------------------------
#------------------------------------------------------------------------------
#Script Execution Starts Here.

buildConfigsXmi = sys.argv[1];
buildConfigsDoc = xml.dom.minidom.parse(buildConfigsXmi)
buildConfigs = buildConfigsDoc.getElementsByTagName("CompileConfigs:ComponentsInfo")
cor = buildConfigs[0].getElementsByTagName("COR")
ns = buildConfigsDoc.getElementsByTagName("NS")
result = createNSHeader(ns[0])
rmd = buildConfigsDoc.getElementsByTagName("RMD")
result+=createRMDHeader(rmd[0])

out_file = open("clASPCfg.c", "w")
out_file.write(headerTemplate.safe_substitute())
out_file.write(result)
out_file.close()

