/*
 * Copyright (C) 2002-2012 OpenClovis Solutions Inc.  All Rights Reserved.
 *
 * This file is available  under  a  commercial  license  from  the
 * copyright  holder or the GNU General Public License Version 2.0.
 * 
 * The source code for  this program is not published  or otherwise 
 * divested of  its trade secrets, irrespective  of  what  has been 
 * deposited with the U.S. Copyright office.
 * 
 * This program is distributed in the  hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied  warranty  of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
 * General Public License for more details.
 * 
 * For more  information, see  the file  COPYING provided with this
 * material.
 */

/*********************************************************************
* ModuleName  : idl
*********************************************************************/
/*********************************************************************
* Description : Marshall routine for ClAlarmUtilTlvT
*     
* THIS FILE IS AUTO-GENERATED BY OPENCLOVIS IDE. EDIT THIS FILE AT
* YOUR OWN RISK. ANY CHANGE TO THIS FILE WILL BE OVERWRITTEN ON
* RE-GENERATION.
*     
*********************************************************************/

#include <clDebugApi.h>

#include "xdrClAlarmUtilTlvT.h"


ClRcT clXdrMarshallClAlarmUtilTlvT(void* pGenVar, ClBufferHandleT msg, ClUint32T isDelete)
{
    ClRcT rc;
    ClUint32T length = 0;
    ClAlarmUtilTlvT* pVar = (ClAlarmUtilTlvT*)pGenVar;

    if ((void*)0 == pVar)
    {
        return CL_XDR_RC(CL_ERR_NULL_POINTER);
    }
    rc = clXdrMarshallClUint32T(&(pVar->type),msg,isDelete);
    if (CL_OK != rc)
    {
        return rc;
    }
    rc = clXdrMarshallClUint32T(&(pVar->length),msg,isDelete);
    if (CL_OK != rc)
    {
        return rc;
    }
    switch(pVar->type)
    {
	case CL_COR_INT8:
	    length = pVar->length;
	    rc = clXdrMarshallPtrClInt8T(pVar->value,length,msg,isDelete);
	    break;
	case CL_COR_UINT8:
	    length = pVar->length;
	    rc = clXdrMarshallPtrClUint8T(pVar->value,length,msg,isDelete);
	    break;
	case CL_COR_INT16:
	    length = pVar->length / 2;
	    rc = clXdrMarshallPtrClInt16T(pVar->value,length,msg,isDelete);
	    break;
	case CL_COR_UINT16:
	    length = pVar->length / 2;
	    rc = clXdrMarshallPtrClUint16T(pVar->value,length,msg,isDelete);
	    break;
	case CL_COR_INT32:
	    length = pVar->length / 4;
	    rc = clXdrMarshallPtrClInt32T(pVar->value,length,msg,isDelete);
	    break;
	case CL_COR_UINT32:
	    length = pVar->length / 4;
	    rc = clXdrMarshallPtrClUint32T(pVar->value,length,msg,isDelete);
	    break;
	case CL_COR_INT64:
	    length = pVar->length / 8;
	    rc = clXdrMarshallPtrClInt64T(pVar->value,length,msg,isDelete);
	    break;
	case CL_COR_UINT64:
	    length = pVar->length / 8;
	    rc = clXdrMarshallPtrClUint64T(pVar->value,length,msg,isDelete);
	    break;
	default:
	    CL_DEBUG_PRINT( CL_DEBUG_ERROR, ("Could not handle this data type. Type is %d\n",pVar->type) );
	    break;
    }
    if (CL_OK != rc)
    {
	CL_DEBUG_PRINT( CL_DEBUG_ERROR,("Could not marshal the value. rc = [0x%x]",rc) );
        return rc;
    }
    return rc;
}
